#!/bin/bash
#
# rip -- loop waiting for CD insertion, then rip and encode it untagged.
# Stephen Crane, April 2001
#
PATH=/usr/local/bin:$PATH
dir=`dirname $0`
. `dirname $dir`/etc/riprc

while true; do
  waitclose $CDROM

  # see if an audio CD has been inserted
  cdparanoia -Q -q -d $CDROM 2>/dev/null
  if [ $? -eq 0 ]; then
    discinfo=`discid $CDROM`
    cdkey=`echo $discinfo | cut -f1 -d' '`
    tracks=`echo $discinfo | cut -f2 -d' '`
    if [ ! -d $UNTAGGED/$cdkey ]; then
	[ ! -d $RIPDIR/$cdkey ] && mkdir -p $RIPDIR/$cdkey
	cd $RIPDIR/$cdkey
	track=`ls -1 *.wav 2>/dev/null | wc -l`
	if [ "$track" == "" ]; then
	    track=0
	fi
	track=`expr $track + 1`
	#echo cdparanoia -B -w -q -d $CDROM ${track}- #2>/dev/null
	cdparanoia -B -w -d $CDROM ${track}- #2>/dev/null
	if [ `ls -1 *.wav | wc -l` -lt $tracks ];  then
	    echo "Hmmm not enough tracks ripped?"
	fi
	eject

	# some CDs have a track-0, remove it
	# No longer necessary, we explicitly start at track 1 (or above)
	#rm -f track00.cdda.wav

	# rename wav files for later encoding to mp3
	mkdir -p $UNTAGGED/$cdkey
	for t in *.wav; do
	    tid=`basename $t .cdda.wav | cut -c 6- | cut -c 0-2`
	    wav=${tid}.wav
	    wavfile=$UNTAGGED/$cdkey/$wav
	    mv $t $wavfile
	done

	# allow RIPDIR to be the same as UNTAGGED
	rmdir --ignore-fail-on-non-empty $RIPDIR/$cdkey
	echo $discinfo > $UNTAGGED/$cdkey/query
	cddb_lookup $UNTAGGED/$cdkey/query
	echo -n 
    fi
  fi
done